3 # B A C K U P N I N J A /()/
6 # Copyright (C) 2004-05 riseup.net -- property is theft.
8 # This program is free software; you can redistribute it and/or modify
9 # it under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 2 of the License, or
11 # (at your option) any later version.
13 # This program is distributed in the hope that it will be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16 # GNU General Public License for more details.
19 #####################################################
22 function setupcolors() {
30 COLORS=($BLUE $GREEN $YELLOW $RED $PURPLE)
34 if [ "$usecolors" == "yes" ]; then
35 local typestr=`echo "$@" | sed 's/\(^[^:]*\).*$/\1/'`
36 [ "$typestr" == "Debug" ] && type=0
37 [ "$typestr" == "Info" ] && type=1
38 [ "$typestr" == "Warning" ] && type=2
39 [ "$typestr" == "Error" ] && type=3
40 [ "$typestr" == "Fatal" ] && type=4
41 color=${COLORS[$type]}
43 echo -e "$color$@$endcolor"
49 # We have the following message levels:
51 # 1 - normal messages - green
52 # 2 - warnings - yellow
55 # First variable passed is the error level, all others are printed
57 # if 1, echo out all warnings, errors, or fatal
58 # used to capture output from handlers
64 [ ${#@} -gt 1 ] || return
68 if [ $type == 100 ]; then
69 typestr=`echo "$@" | sed 's/\(^[^:]*\).*$/\1/'`
70 [ "$typestr" == "Debug" ] && type=0
71 [ "$typestr" == "Info" ] && type=1
72 [ "$typestr" == "Warning" ] && type=2
73 [ "$typestr" == "Error" ] && type=3
74 [ "$typestr" == "Fatal" ] && type=4
77 types=(Debug Info Warning Error Fatal)
78 typestr="${types[$type]}: "
83 if [ $echo_debug_msg == 1 ]; then
84 echo -e "$typestr$@" >&2
86 colorize "$typestr$@" >&2
89 if [ $print -lt $loglevel ]; then
95 if [ -w "$logfile" ]; then
96 echo -e `date "+%h %d %H:%M:%S"` "$@" >> $logfile
100 function passthru() {
122 messages[$msgcount]=$1
130 function setsection() {
135 # sets a global var with name equal to $1
136 # to the value of the configuration parameter $1
142 ret=`awk -f $scriptdir/parseini S=$CURRENT_SECTION P=$CURRENT_PARAM $CURRENT_CONF_FILE`
143 # if nothing is returned, set the default
144 if [ "$ret" == "" -a "$2" != "" ]; then
148 # replace * with %, so that it is not globbed.
149 ret="${ret//\\*/__star__}"
151 # this is weird, but single quotes are needed to
152 # allow for returned values with spaces. $ret is still expanded
153 # because it is in an 'eval' statement.
158 # enforces very strict permissions on configuration file $file.
161 function check_perms() {
163 local perms=`ls -ld $file`
165 if [ "$perms" != "------" ]; then
166 echo "Configuration files must not be group or world readable! Dying on file $file"
167 fatal "Configuration files must not be group or world readable! Dying on file $file"
169 if [ `ls -ld $file | awk '{print $3}'` != "root" ]; then
170 echo "Configuration files must be owned by root! Dying on file $file"
171 fatal "Configuration files must be owned by root! Dying on file $file"
175 # simple lowercase function
177 echo "$1" | tr [:upper:] [:lower:]
180 # simple to integer function
182 echo "$1" | tr [:alpha:] -d
186 # function isnow(): returns 1 if the time/day passed as $1 matches
187 # the current time/day.
189 # format is <day> at <time>:
195 # we grab the current time once, since processing
196 # all the configs might take more than an hour.
199 nowdayofweek=`date +%A`
200 nowdayofweek=`tolower "$nowdayofweek"`
205 whendayofweek=$1; at=$2; whentime=$3;
206 whenday=`toint "$whendayofweek"`
207 whendayofweek=`tolower "$whendayofweek"`
208 whentime=`echo "$whentime" | sed 's/:[0-9][0-9]$//' | sed -r 's/^([0-9])$/0\1/'`
210 if [ "$whendayofweek" == "everyday" -o "$whendayofweek" == "daily" ]; then
211 whendayofweek=$nowdayofweek
214 if [ "$whenday" == "" ]; then
215 if [ "$whendayofweek" != "$nowdayofweek" ]; then
216 whendayofweek=${whendayofweek%s}
217 if [ "$whendayofweek" != "$nowdayofweek" ]; then
221 elif [ "$whenday" != "$nowday" ]; then
225 [ "$at" == "at" ] || return 0
226 [ "$whentime" == "$nowtime" ] || return 0
234 This script allows you to coordinate system backup by dropping a few
235 simple configuration files into /etc/backup.d/. Typically, this
236 script is run hourly from cron.
238 The following options are available:
239 -h, --help This usage message
240 -d, --debug Run in debug mode, where all log messages are
241 output to the current shell.
242 -f, --conffile FILE Use FILE for the main configuration instead
243 of /etc/backupninja.conf
244 -t, --test Run in test mode, no actions are actually taken.
245 -n, --now Perform actions now, instead of when they
247 --run FILE Execute the specified action file and then exit.
248 When using colored output, there are:
251 debug "Debugging info (when run with -d)"
252 info "Informational messages (verbosity level 4)"
253 warning "Warnings (verbosity level 3 and up)"
254 error "Errors (verbosity level 2 and up)"
255 fatal "Fatal, halting errors (always shown)"
259 ## this function handles the running of a backup action
261 ## these globals are modified:
262 ## fatals, errors, warnings, actions_run, errormsg
265 function process_action() {
271 # skip over this config if "when" option
272 # is not set to the current time.
273 getconf when "$defaultwhen"
274 if [ "$processnow" == 1 ]; then
275 info ">>>> starting action $file (because of --now)"
276 elif [ "$when" == "hourly" ]; then
277 info ">>>> starting action $file (because 'when = hourly')"
285 if [ $ret == 0 ]; then
286 debug "skipping $file because it is not $w"
289 info ">>>> starting action $file (because it is $w)"
295 let "actions_run += 1"
298 local bufferfile="/tmp/backupninja.buffer.$$"
299 echo "" > $bufferfile
302 . $scriptdir/$suffix $file
305 echo $a >> $bufferfile
306 [ $debug ] && colorize "$a"
310 # ^^^^^^^^ we have a problem! we can't grab the return code "$?". grrr.
313 _warnings=`cat $bufferfile | grep "^Warning: " | wc -l`
314 _errors=`cat $bufferfile | grep "^Error: " | wc -l`
315 _fatals=`cat $bufferfile | grep "^Fatal: " | wc -l`
317 ret=`grep "\(^Warning: \|^Error: \|^Fatal: \)" $bufferfile`
319 if [ $_fatals != 0 ]; then
320 msg "*failed* -- $file"
321 errormsg="$errormsg\n== fatal errors from $file ==\n\n$ret\n"
322 passthru "Fatal: <<<< finished action $file: FAILED"
323 elif [ $_errors != 0 ]; then
324 msg "*error* -- $file"
325 errormsg="$errormsg\n== errors from $file ==\n\n$ret\n"
326 error "<<<< finished action $file: ERROR"
327 elif [ $_warnings != 0 ]; then
328 msg "*warning* -- $file"
329 errormsg="$errormsg\n== warnings from $file ==\n\n$ret\n"
330 warning "<<<< finished action $file: WARNING"
332 msg "success -- $file"
333 info "<<<< finished action $file: SUCCESS"
336 let "fatals += _fatals"
337 let "errors += _errors"
338 let "warnings += _warnings"
341 #####################################################
345 conffile="/etc/backupninja.conf"
348 ## process command line options
350 while [ $# -ge 1 ]; do
353 -d|--debug) debug=1;;
354 -t|--test) test=1;debug=1;;
355 -n|--now) processnow=1;;
360 echo "-f|--conffile option must be followed by an existing filename"
361 fatal "-f|--conffile option must be followed by an existing filename"
364 # we shift here to avoid processing the file path
373 echo "--run option must be fallowed by a backupninja action file"
374 fatal "--run option must be fallowed by a backupninja action file"
381 echo "Unknown option $1"
382 fatal "Unknown option $1"
394 ## Load and confirm basic configuration values
397 if [ ! -r "$conffile" ]; then
398 echo "Configuration file $conffile not found."
399 fatal "Configuration file $conffile not found."
402 scriptdir=`grep scriptdirectory $conffile | awk '{print $3}'`
403 if [ ! -n "$scriptdir" ]; then
404 echo "Cound not find entry 'scriptdirectory' in $conffile"
405 fatal "Cound not find entry 'scriptdirectory' in $conffile"
408 if [ ! -d "$scriptdir" ]; then
409 echo "Script directory $scriptdir not found."
410 fatal "Script directory $scriptdir not found."
415 # get global config options (second param is the default)
416 getconf configdirectory /etc/backup.d
418 getconf reportsuccess yes
419 getconf reportwarning yes
421 getconf when "Everyday at 01:00"
423 getconf logfile /var/log/backupninja.log
424 getconf usecolors "yes"
425 getconf SLAPCAT /usr/sbin/slapcat
426 getconf LDAPSEARCH /usr/bin/ldapsearch
427 getconf RDIFFBACKUP /usr/bin/rdiff-backup
428 getconf MYSQL /usr/bin/mysql
429 getconf MYSQLHOTCOPY /usr/bin/mysqlhotcopy
430 getconf MYSQLDUMP /usr/bin/mysqldump
431 getconf GZIP /bin/gzip
432 getconf RSYNC /usr/bin/rsync
434 getconf VSERVERINFO /usr/sbin/vserver-info
435 getconf VSERVER /usr/sbin/vserver
436 getconf VROOTDIR `if [ -f "$VSERVERINFO" ]; then $VSERVERINFO info SYSINFO |grep vserver-Rootdir | awk '{print $2}'; fi`
438 if [ ! -d "$configdirectory" ]; then
439 echo "Configuration directory '$configdirectory' not found."
440 fatal "Configuration directory '$configdirectory' not found."
443 [ -f "$logfile" ] || touch $logfile
445 if [ "$UID" != "0" ]; then
446 echo "$0 can only be run as root"
450 if [ "$vservers" == "yes" -a ! -d "$VROOTDIR" ]; then
451 echo "vservers option set in config, but $VROOTDIR is not a directory!"
452 fatal "vservers option set in config, but $VROOTDIR is not a directory!"
455 ## Process each configuration file
457 # by default, don't make files which are world or group readable.
460 # these globals are set by process_action()
467 if [ "$singlerun" ]; then
470 files=`find $configdirectory -mindepth 1 | sort -n`
473 for file in $files; do
474 [ -f "$file" ] || continue
478 base=`basename $file`
479 if [ "${base:0:1}" == "0" ]; then
480 info "Skipping $file"
484 if [ -e "$scriptdir/$suffix" ]; then
485 process_action $file $suffix
487 error "Can't process file '$file': no handler script for suffix '$suffix'"
488 msg "*missing handler* -- $file"
492 ## mail the messages to the report address
494 if [ $actions_run == 0 ]; then doit=0
495 elif [ "$reportemail" == "" ]; then doit=0
496 elif [ $fatals != 0 ]; then doit=1
497 elif [ $errors != 0 ]; then doit=1
498 elif [ "$reportsuccess" == "yes" ]; then doit=1
499 elif [ "$reportwarning" == "yes" -a $warnings != 0 ]; then doit=1
503 if [ $doit == 1 ]; then
504 debug "send report to $reportemail"
506 [ $warnings == 0 ] || subject="WARNING"
507 [ $errors == 0 ] || subject="ERROR"
508 [ $fatals == 0 ] || subject="FAILED"
511 for ((i=0; i < ${#messages[@]} ; i++)); do
515 } | mail $reportemail -s "backupninja: $hostname $subject"
518 if [ $actions_run != 0 ]; then
519 info "FINISHED: $actions_run actions run. $fatals fatal. $errors error. $warnings warning."